/*
** $Id: utils.c, v 1.0.1 by Alexander Walz - Initiated: October 17, 2006
   Revision 08.08.2009 22:13:15
** See Copyright Notice in agena.h
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "../ports/fltk/FL/Fl.H"
//#include "../ports/fltk/FL/Fl_Window.H"
//#include "../ports/fltk/FL/Fl_Box.H"

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#  include <FL/Fl_Double_Window.H>
#include <FL/threads.h>
/* the following package ini declarations must be included after `#include <` and before `include #` ! */

#define gui_c
#define LUA_LIB


#ifdef __cplusplus
extern "C"
{
#endif


#include "agena.h"
#include "agnxlib.h"
#include "agenalib.h"

#if !(defined(LUA_DOS) || defined(__OS2__) || defined(LUA_ANSI))
#define AGENA_GUILIBNAME "gui"
LUALIB_API int (luaopen_gui) (lua_State *L);
#endif


Fl_Thread prime_thread;

void *prime_func (void* p) {
  Fl::lock();
  Fl::wait();
  Fl::unlock();
  return 0L;
}

static int gui_open (lua_State *L) {
//  Fl::lock();
  Fl_Double_Window *window = new Fl_Double_Window(300,180);
 window->begin();
  Fl_Box *box1 = new Fl_Box(20,40,260,100,"Hello!");
  box1->box(FL_UP_BOX);
  box1->labelsize(36);
  box1->labelfont(FL_BOLD+FL_ITALIC);
  box1->labeltype(FL_SHADOW_LABEL);
  window->end();
  window->show();

  window = new Fl_Double_Window(300,180);
 window->begin();

  Fl_Box *box2 = new Fl_Box(20,40,260,100,"Hello, World!");
  box2->box(FL_UP_BOX);
  box2->labelsize(36);
  box2->labelfont(FL_BOLD+FL_ITALIC);
  box2->labeltype(FL_SHADOW_LABEL);
  window->end();
  window->set_non_modal();
  window->show();
  // Enable multi-thread support by locking from the main
  // thread.  Fl::wait() and Fl::run() call Fl::unlock() and
  // Fl::lock() as needed to release control to the child threads
  // when it is safe to do so...
  Fl::lock();
  fl_create_thread(prime_thread, prime_func, box1);
  fl_create_thread(prime_thread, prime_func, box2);
Fl::delete_widget(window);
//do_callback()
int ret = Fl::run();
lua_pushnumber(L, ret);
  return 1;
}

static const luaL_Reg gui[] = {
  {"open", gui_open},
  {NULL, NULL}
};


static void createmetatable (lua_State *L) {
  lua_createtable(L, 0, 1);  /* create metatable for strings */
  lua_pushliteral(L, "");  /* dummy string */
  lua_pushvalue(L, -2);
  lua_setmetatable(L, -2);  /* set string metatable */
  agn_poptop(L);  /* pop dummy string */
  lua_pushvalue(L, -2);  /* string library... */
  lua_setfield(L, -2, "__index");  /* ...is the __index metamethod */
  agn_poptop(L);  /* pop metatable */
}


/*
** Open utils library
*/
LUALIB_API int luaopen_gui (lua_State *L) {
//  luaL_newmetatable(L, "stringarray");
//  luaL_register(L, NULL, str_arraylib);
  luaL_register(L, AGENA_GUILIBNAME, gui);
  createmetatable(L);
  return 1;
}

/* ====================================================================== */

#ifdef __cplusplus
}
#endif